# generator-aio-angular

All In One [Yeoman](http://yeoman.io) generator for AngularJS 1.3, using `gulp` and `ui-router` with `material design`, based on John Papa's [generator-hottowel](https://github.com/johnpapa/generator-hottowel) and [angular-styleguide](https://github.com/johnpapa/angular-styleguide).

Wanna use **Webpack + ES6**? Check the [angular1-webpack-starter](https://github.com/PinkyJie/angular1-webpack-starter) project.

> Pure front-end implementation, all API interaction are mocked using [angular-mocks](https://docs.angularjs.org/api/ngMock). The [server folder](app/templates/server) is just a placeholder here, you can use any back-end technique. 

## Preview

Check out a [demo site](http://pinkyjie.com/generator-aio-angular/#/) generated by this generator.

> The dome site is a pure front-end implementation, so you can use any email/password to login, see [mock file](app/templates/client/source/test/e2e/mocks/e2e.user.js#L23) for detail. It is hosted on Github pages, no back-end support, so we use `#` style URL.

## Feature

* Material Design
   * Using [LumX](http://ui.lumapps.com/).
   * Why not [Angular Material](https://material.angularjs.org)? Many common used components are missing, for exmaple, dropdown menu.
   * Why not [Bootstrap Material](http://fezvrasta.github.io/bootstrap-material-design/)? Many components are not implemented, not pure material design.
* Flex Layout
   * Using flex layout for main layout and many other places.
* Responsive
   * Support mutiple devices with different screen size.
   * Easy responsive implementation, very convenient to support small screen devices. (see [responsive.styl](app/templates/client/source/styles/responsive.styl))
* Animation
   * Using [animate.css](https://daneden.github.io/animate.css/).
   * All the animation defined by `animate.css` can be used directly as keyfrmae animation. (see [content.styl](app/templates/client/source/styles/layout/content.styl#L28))
* Splited Gulp Tasks
   * Gulp tasks are splited in different files by category. (see [gulp folder](app/templates/gulp))
* More understandable router design
   * Using [ui-router](https://github.com/angular-ui/ui-router) for main layout. (see [layout.route.js](app/templates/client/source/app/layout/layout.route.js))
* Easy implementation for Sidebar Navigation and Breadcrumb
   * See [sidebar.controller.js](app/templates/client/source/app/layout/sidebar.controller.js) and [breadcrumb.controller.js](app/templates/client/source/app/layout/breadcrumb.controller.js).

## Getting Started

```bash
npm install -g yo
npm install -g generator-aio-angular
yo aio-angular
```

## How to do development
Many files(prefixed by `_`) under `app/templates` folder include `<%= appNmae %>` tag which needs to be replaced by Yeoman, it's not very convenient to do development under `app/templates` folder. That's the reason why I add a script called `change-env.js`.

* make `app/templates` ready for developent:
```bash
npm run-script env dev
```
> This will rename all files prefixed by `_` to normal name and replace the placeholder tag to normal content.

* change back from development:
```bash
npm run-script env prod
```

## Blog Posts related(written in Chinese)
* [相关博文](http://pinkyjie.com/tags/generator-aio-angular/)

## Future Plan
Check the [issues](https://github.com/PinkyJie/generator-aio-angular/issues/created_by/PinkyJie)

## License

MIT


